Status: Closed Start date: 27 Jan 2014

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Tidying Estimated time: 2.50 hours

Target version: CoCoALib-0.99532 Spent time: 2.00 hours

Description

The ConvertTo fn is used extensively in the interface between the C5 interpreter and the CoCoALin fns which actually do the work. 

To improve readability of this code Anna proposes adding a variant of ConvertTo which accepts a 2nd arg, being a CoCoA::ErrorInfo

object containing the error which should be thrown if conversion fails (thus allowing more meaningful messages to appear in C5).

Related issues:

Related to CoCoALib - Feature #233: AsINT and AsRAT  -- ConvertTo<BigInt> and... Closed 25 Sep 2012

Related to CoCoA-5 - Feature #317: BuiltInFunctions: evalArgAsLong Closed 20 Feb 2013

Related to CoCoALib - Feature #61: Conversion functions -- documentation Closed 13 Dec 2011

History

#1 - 28 Feb 2014 16:30 - Anna Maria Bigatti

- Status changed from New to Feedback

- Assignee set to John Abbott

- Target version set to CoCoALib-0.9953

- % Done changed from 0 to 90

Jon implemented this and forgot to say it?

anyway it is very nice:

code was

    long n;

    if (!IsConvertible(n, NumIndets)) CoCoA_ERROR(ERR::ArgTooBig, "RingQQt");

    return RingQQt(n);

now is

    const ErrorInfo ErrMesg(ERR::ArgTooBig, "RingQQt");

    return RingQQt(ConvertTo<long>(NumIndets, ErrMesg));

it can be done in a single line, but this is more readable.

Of course this means that we are always creating the error message (instead of only when the error occurs), but I find the code much more readable

(therefore maintanable).
#2 - 28 Feb 2014 17:10 - Anna Maria Bigatti

added example and documentation (cvs-ed)

#3 - 21 Mar 2014 14:29 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.9953 to CoCoALib-0.99532

#4 - 01 Apr 2014 19:33 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

We are all happy about this.  Tested and documented.  Closing.

#5 - 03 Apr 2014 11:54 - Anna Maria Bigatti

- Estimated time set to 2.50 h
